shuffle = function(o){ //v1.0
	for(var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
	return o;
};

function strrpos(haystack, needle, offset) {
    // Finds position of last occurrence of a string within another string  
    // 
    // version: 810.1317
    // discuss at: http://phpjs.org/functions/strrpos
    // +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   bugfixed by: Onno Marsman
    // *     example 1: strrpos('Kevin van Zonneveld', 'e');
    // *     returns 1: 16
    var i = (haystack+'').lastIndexOf( needle, offset ); // returns -1
    return i >= 0 ? i : false;
}

function substr(f_string, f_start, f_length) {
    // Returns part of a string  
    // 
    // version: 810.1317
    // discuss at: http://phpjs.org/functions/substr
    // +     original by: Martijn Wieringa
    // +     bugfixed by: T.Wild
    // +      tweaked by: Onno Marsman
    // *       example 1: substr('abcdef', 0, -1);
    // *       returns 1: 'abcde'
    // *       example 2: substr(2, 0, -6);
    // *       returns 2: ''
    f_string += '';

    if(f_start < 0) {
        f_start += f_string.length;
    }

    if(f_length == undefined) {
        f_length = f_string.length;
    } else if(f_length < 0){
        f_length += f_string.length;
    } else {
        f_length += f_start;
    }

    if(f_length < f_start) {
        f_length = f_start;
    }

    return f_string.substring(f_start, f_length);
}

function applyTheme(theFilename) {

	// retrieve document's HEAD section
	var head = document.getElementsByTagName("head")[0];

	// remove all stylesheets
	var sheets = document.getElementsByTagName("link");
	for (var i = 0; i<sheets.length; i++) {
		head.removeChild(sheets[i]);
	}
  
  // Get theme setting
	if (System.Gadget.Settings.read("cfgTheme")) {
		var myTheme = System.Gadget.Settings.read("cfgTheme");
	} else {
    var myTheme = 'bento';
  }

	link = document.createElement('link');
	link.href = 'themes/' + myTheme + '/' + theFilename;
	link.rel = 'stylesheet';
	link.type = "text/css";
	head.appendChild(link);
}

function getLocale() {

  if ( navigator ) {
  
    if ( navigator.language ) {
      return navigator.language;
      
    } else if (navigator.browserLanguage) {
      return navigator.browserLanguage;
    
    } else if (navigator.systemLanguage) {
      return navigator.systemLanguage;
    
    } else if (navigator.userLanguage) {
      return navigator.userLanguage;
    }
  }
}

// Written by TiM-International.net
//    Usage: if (is_within_clock("22:00:00", "03:59:59")) alert("True!");
//    Alt. usage: if (is_within_clock("22", "03")) alert("True!");
function is_within_clock(strFrom, strTo) {

	// Break out time values
	strFrom = strFrom.split(":");
	strTo = strTo.split(":");
	
	// Create time objects
	var oNowTime = new Date();
	var oFromTime = new Date(); 
	var oToTime = new Date();

	// Set clock
	oFromTime.setHours( ((strFrom[0]) ? strFrom[0] : 0) );
	oFromTime.setMinutes( ((strFrom[1]) ? strFrom[1] : 0) );
	oFromTime.setSeconds( ((strFrom[2]) ? strFrom[2] : 0) );
	
	oToTime.setHours( ((strTo[0]) ? strTo[0] : 23) );
	oToTime.setMinutes( ((strTo[1]) ? strTo[1] : 59) );
	oToTime.setSeconds( ((strTo[2]) ? strTo[2] : 59) );
	
	// If TO is earlier than FROM, then set tomorrow as TO-date
	if (oFromTime >= oToTime) {
		oToTime.setDate(oFromTime.getDate() + 1);
	}
	
	// Compare case 1
	if ((oFromTime <= oNowTime) && (oNowTime <= oToTime)) {
		return true;
	} else {
		// Set data for case 2
		oFromTime.setDate( oFromTime.getDate() -1 );
		oToTime.setDate( oToTime.getDate() -1 );
	}
	
	// Compare case 2
	if ((oFromTime <= oNowTime) && (oNowTime <= oToTime)) {
		return true;
	}
}

function xmlGetRandomAds(adSpot, numAds) {
	
  // Variables
	var arrayRow = 0;
	var arrayAds = new Array();
	var oDate = new Date();
	var timeNow = oDate.getTime()/1000;
	var xmlDoc = new ActiveXObject("Msxml.DOMDocument");
  if (numAds < 1) numAds = 1;
  
  // Prepare array or string result
  if (numAds == 1) {
    var ads = new String();
  } else {
    var ads = new Array();
  }
  
  // Prepare document
	xmlDoc.async = false;
	xmlDoc.load("ads.xml");
  
  // Make sure 'ads' is an existing node
	if (xmlDoc.selectSingleNode("ads")) {
  
    // Make sure selected adtype node exists
    if (xmlDoc.selectSingleNode("ads").selectSingleNode(adSpot)) {
    
      // Step through each ad
      var row = 0;
      for (var i=0; i < xmlDoc.selectSingleNode("ads").selectSingleNode(adSpot).childNodes.length; i++) {
        var xmlAdNode = xmlDoc.selectSingleNode("ads").selectSingleNode(adSpot).childNodes.item(i);
        
        // Make sure ad has not expired
        if ((xmlAdNode.getAttribute("begin") < timeNow) && (timeNow < xmlAdNode.getAttribute("end"))) {
        
          // Make sure ad is avilable for current hours
          if (is_within_clock(xmlAdNode.getAttribute("fromclock"), xmlAdNode.getAttribute("toclock"))) {
          
            // Grab current ad to haystack
            if (xmlAdNode.text.length) arrayAds[row] = xmlAdNode.text;
            row++;
          }
        }
      }
      
      // Make sure we have a haystack
      if (arrayAds.length > 0) {
      
        // Make sure we have more than one contents in haystack
        if (arrayAds.length > 1) {
        
          // Shuffle ads
          arrayAds = shuffle(arrayAds);
        }
        /*
        // Re-index array
        var newArrayAds = new Array();
        var row = 0;
        for (var i in arrayAds) {
          newArrayAds[row] = i + arrayAds[i];
        }
        arrayAds = newArrayAds;
        */
        
        // Grab ad(s) from haystack
        for (var i=0; i < arrayAds.length && i < numAds; i++) {
          if (numAds == 1) {
            ads = arrayAds[i];
          } else {
            ads[arrayRow] = arrayAds[i];
            arrayRow++;
          }
        }
      }
    }
  }
  
  // Display empty ad
  if (numAds == 1) {
    if (!ads) ads = 'fel';
  } else {
    if (ads.lenngth < 1) ads = Array('');
  }
  
  return ads;
}

// For debugging
function dump(obj) {
  var out = '';
  for (var i in obj) {
    out += i + ": " + obj[i] + "\n";
  }

  var oShell = new ActiveXObject("WScript.Shell");
  oShell.Popup(out);
}
