function httpUpdateCheck() {

	// Don't check, if an update is already detected previously
	//if (System.Gadget.Settings.read("latestVersion") && System.Gadget.Settings.read("latestVersion") < System.Gadget.version) return;
	
	// Create the HTTP object
	var httpReq = new ActiveXObject("Msxml2.XMLHTTP.6.0");
	
	// Create the HTTP return handler
	httpReq.onreadystatechange = function() {
		
		// Discontinue if not in completed state
		if (httpReq.readyState != 4) return;
			
		// Discontinue if not Response OK
		if (httpReq.status != 200) return;
		
		// Log latest version
    System.Gadget.Settings.write("latestVersion", parseFloat(httpReq.responseText));
    
    // Perform an operation if a new version is found
		if (parseFloat(httpReq.responseText) > System.Gadget.version) {
		}
		
	}
	
	// Launch HTTP
	httpReq.open("GET", apiVersionURL + "?Version=" + System.Gadget.version + "&PlatformVersion=" + System.Gadget.platformVersion + "&ISO_Locale=" + getLocale(), true);
	httpReq.setRequestHeader("Cache-Control", "no-store, no-cache, must-revalidate");
	httpReq.setRequestHeader("Cache-Control", "post-check=0, pre-check=0");
	httpReq.setRequestHeader("Pragma", "no-cache");
	httpReq.setRequestHeader("If-Modified-Since", "Tue, 01 Jan 2008 00:00:00 GMT");
	httpReq.send();
	
}

// Check for ads update
function httpAdsCheck() {

	// Create the XML object
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.6.0");
	xmlDoc.async = false;

	// Open XML file
	xmlDoc.load("ads.xml");
	
	// Detect current version of XML doc
	if (xmlDoc.selectSingleNode("ads")) {
		if (xmlDoc.selectSingleNode("ads").getAttribute("version")) {
			var myAdfileVersion = xmlDoc.selectSingleNode("ads").getAttribute("version");
		}
	}
	
	// Create the HTTP object
	var httpReq = new ActiveXObject("Msxml2.XMLHTTP.6.0");
	
	// Create the HTTP return handler
	httpReq.onreadystatechange = function() {
		
		// Discontinue if not in completed state
		if (httpReq.readyState != 4) {
			return;
		}
			
		// Discontinue if not Response OK
		if (httpReq.status != 200) {
			return;
		}
			
		// Check content type
		if (httpReq.getResponseHeader("Content-type").toLowerCase() != 'text/plain; charset=utf-8') {
			return;
		}
		
		// Check if new version
		if (httpReq.responseText != myAdfileVersion) {
			httpAdsUpdate();
		}
	
	}
	
	// Launch HTTP
	httpReq.open("GET", apiAdsURL + "?ISO_Locale=" + getLocale() + "&Return=Version", true);
	httpReq.setRequestHeader("Cache-Control", "no-store, no-cache, must-revalidate");
	httpReq.setRequestHeader("Cache-Control", "post-check=0, pre-check=0");
	httpReq.setRequestHeader("Pragma", "no-cache");
	httpReq.setRequestHeader("If-Modified-Since", "Tue, 01 Jan 2008 00:00:00 GMT");
	httpReq.send();
	
}

// Download ads update
function httpAdsUpdate() {

	// Create the HTTP object
	var httpReq = new ActiveXObject("Msxml2.XMLHTTP.6.0");
	
	// Create the HTTP return handler
	httpReq.onreadystatechange = function() {
		
		// Discontinue if not in completed state
		if (httpReq.readyState != 4) {
			return;
		}
			
		// Discontinue if not Response OK
		if (httpReq.status != 200) {
			return;
		}
			
		// Check content type
		if (httpReq.getResponseHeader("Content-type").toLowerCase() != 'application/xml; charset=utf-8') {
			return;
		}
		
		// Check if valid URL and value
		if (httpReq.responseText) {
		
			// Create the XML object
			var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.6.0");
			xmlDoc.async = false;
				
			// Save the XML data
			if (xmlDoc.loadXML(httpReq.responseText)) {
				xmlDoc.save(System.Gadget.path + "\\ads.xml");
			}
		}
	}
	
	// Launch HTTP
	httpReq.open("GET", apiAdsURL + "?ISO_Locale=" + getLocale(), false);
	httpReq.setRequestHeader("Cache-Control", "no-store, no-cache, must-revalidate");
	httpReq.setRequestHeader("Cache-Control", "post-check=0, pre-check=0");
	httpReq.setRequestHeader("Pragma", "no-cache");
	httpReq.setRequestHeader("If-Modified-Since", "Tue, 01 Jan 2008 00:00:00 GMT");
	httpReq.send();
}

// Check
function httpCheckChannels(silentMode) {
  var oDate = new Date();
	var myChanListChecksum = new String();
	
	// Set next auto update timestamp
	System.Gadget.Settings.write("cfgNextAutoUpdate", (oDate.getTime()/1000)+604800);
	
	document.getElementById("channels").innerHTML = '<div align="center"><br /><br /><div id="loading_animation"></div><br /><div id="updatenotice" style="font-size: 16px;">' + LANG_TEXT_Checking_for_updates  + '</div></div>';

	// Create the XML object
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.6.0");
	xmlDoc.async = false;

	// Open XML file
	xmlDoc.load("channels.xml");
		
	// Detect current version
	if (xmlDoc.selectSingleNode("channels")) {
		if (xmlDoc.selectSingleNode("channels").getAttribute("md5")) {
			myChanListChecksum = xmlDoc.selectSingleNode("channels").getAttribute("md5");
		}
	}
	
	// Create the HTTP object
	var httpReq = new ActiveXObject("Msxml2.XMLHTTP.6.0");
	
	// Create the HTTP return handler
	httpReq.onreadystatechange = function() {
		
		// Discontinue if not in completed state
		if (httpReq.readyState < 4) {
			return;
		}
    
		// Discontinue if not Response OK
		if (httpReq.status != 200) {
			document.getElementById("channels").innerHTML += '<div align="center"><br /><br /><div id="updatenotice" style="font-size: 16px;">' + LANG_TEXT_Error_Try_again_later + '<br />HTTP '+ httpReq.status +'</div></div>';
			return;
		}
		
		// Check content type
		if (httpReq.getResponseHeader("Content-Type").toLowerCase() != 'text/plain; charset=utf-8') {
			document.getElementById("channels").innerHTML += '<div align="center"><br /><br /><div id="updatenotice" style="font-size: 16px;">' + LANG_TEXT_Error_Try_again_later + '</div><br />Invalid content type</div>';
			return;
		}
		
		// Check valid URL and value here
		if (httpReq.responseText != myChanListChecksum) {
			document.getElementById("channels").innerHTML = '<div align="center"><br /><br /><div id="loading_animation"></div><br /><div id="updatenotice" style="font-size: 16px;">' + LANG_TEXT_Updating_channels_list + '</div></div>';
			httpDownloadChannels(silentMode);
		} else {
			document.getElementById("channels").innerHTML = '<div align="center"><br /><br /><div id="updatenotice" style="font-size: 16px;">' + LANG_TEXT_No_updates_available + '</div></div>';
		}
    
    if (silentMode == true) xmlPrintChannels();
	}
	
	// Launch HTTP
	httpReq.open("GET", apiChanListURL + "?Return=md5", true);
	httpReq.setRequestHeader("Cache-Control", "no-store, no-cache, must-revalidate");
	httpReq.setRequestHeader("Cache-Control", "post-check=0, pre-check=0");
	httpReq.setRequestHeader("Pragma", "no-cache");
	httpReq.setRequestHeader("If-Modified-Since", "Tue, 01 Jan 2008 00:00:00 GMT");
	httpReq.send();
}

// Download
function httpDownloadChannels(silentMode) {

	// Create the HTTP object
	var httpReq = new ActiveXObject("Msxml2.XMLHTTP.6.0");
	
	// Create the HTTP return handler
	httpReq.onreadystatechange = function() {
	
		// Discontinue if not in completed state
		if (httpReq.readyState != 4) return;
			
		// Discontinue if not Response OK
		if (httpReq.status != 200) return;
			
		// Check content type
		if (httpReq.getResponseHeader("Content-type").toLowerCase() != 'application/xml; charset=utf-8') {
			document.getElementById("channels").innerHTML = '<div align="center"><br /><br /><div id="updatenotice" style="font-size: 16px;">' + LANG_TEXT_Error_Try_again_later + '</div></div>';
			return;
		}
		
		if (httpReq.responseText) {
		
			var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.6.0");
			xmlDoc.async = false;
			
			if (xmlDoc.loadXML(httpReq.responseText)) {
				xmlDoc.save(System.Gadget.path + "\\channels.xml");
				document.getElementById("channels").innerHTML = '<div align="center"><br /><br /><div id="updatenotice" style="font-size: 16px;">' + LANG_TEXT_Channel_list_updated + '</div></div>';
				return;
			}
			
			document.getElementById("channels").innerHTML = '<div align="center"><br /><br /><div id="updatenotice" style="font-size: 16px;">' + LANG_TEXT_Error_Try_again_later + '</div></div>';
		}
    
    if (silentMode == true) xmlPrintChannels();
	}
	
	// Launch HTTP
	httpReq.open("GET", apiChanListURL, false);
	httpReq.setRequestHeader("Cache-Control", "no-store, no-cache, must-revalidate");
	httpReq.setRequestHeader("Cache-Control", "post-check=0, pre-check=0");
	httpReq.setRequestHeader("Pragma", "no-cache");
	httpReq.setRequestHeader("If-Modified-Since", "Tue, 01 Jan 2008 00:00:00 GMT");
	httpReq.send();
}

// Automatically update gadget
function httpUpdateGadget() {
  httpReq = new ActiveXObject("Microsoft.XMLHTTP");
  httpReq.onreadystatechange = function() {
    
    // Discontinue if not in completed state
    if (httpReq.readyState != 4) return;
    
    // Discontinue if not Response OK
    if (httpReq.status != 200) return;
    
    // Set filename to gadget's folder name
    var filename = "test" + System.Gadget.path.substr(strrpos(System.Gadget.path, "\\")+1);
    
    var httpStream = new ActiveXObject("ADODB.Stream");
    httpStream.Type = 1; // 1=Binary, 2=ASCII
    httpStream.Open();
    httpStream.Write(httpReq.responseBody);
    httpStream.SaveToFile(System.Gadget.path + "\\" + filename, 2);
    httpStream.Close;
    httpStream = null;
	  
    // Execute downloaded gadget
    System.Shell.execute(System.Gadget.path + "\\" + filename);
    
    // Close this gadget -because file cannot be in use-
	  System.Gadget.close();
	}
	httpReq.open("GET", urlGadget, false);
  httpReq.setRequestHeader("Cache-Control", "no-cache");
  httpReq.send(null);
}